﻿using System;
using System.Drawing;
using System.Windows.Forms;
using GTA;
using GTA.Native;
using GTA.Math;
using PoliceMod2;
using System.Threading;
using System.Media;

//REMEMBER TO REFERENCE POLICEMOD, SCRIPTHOOK, NATIVEUI, ETC...
//Documentation + Better API soon... Have fun breaking the mod :)
public class Main : Script
{
    //Determines if the callout is selected or not
    bool requestactive = false;
    //The position of the callout
    private Vector3 position;
    //The blip location of the callout
    private Blip eventblip;
    //The name of the street
    private string name;
    //The location of the policemod directory, will be made easier in the near future
    string location;
    //Create a new sound player to inject into the game
    SoundPlayer Sound = new SoundPlayer();
    //Enemy Ped
    Ped enemy;
    //Create a new random
    Random rand;
    //Has the callout been accepted?
    bool accepted = false;
    //The names of the dispatch audio
    string[] sounds = { "CITIZENS_REPORT_01", "CITIZENS_REPORT_02", "CITIZENS_REPORT_03", "CITIZENS_REPORT_04", "OFFICERS_REPORT_01", "OFFICERS_REPORT_02", "OFFICERS_REPORT_03", "CITIZENS_REPORT_01" };
    string[] sounds2 = { "CRIME_GRAND_THEFT_AUTO_01", "CRIME_GRAND_THEFT_AUTO_02", "CRIME_GRAND_THEFT_AUTO_03", "CRIME_GRAND_THEFT_AUTO_04", "CRIME_OFFICER_IN_NEED_OF_ASSISTANCE_01", "CRIME_OFFICER_IN_NEED_OF_ASSISTANCE_02", "CRIME_OFFICER_IN_NEED_OF_ASSISTANCE_03", "CRIME_RESIST_ARREST_01" };
    string[] sounds3 = { "REPORT_RESPONSE_COPY_01", "REPORT_RESPONSE_COPY_02", "REPORT_RESPONSE_COPY_03", "REPORT_RESPONSE_COPY_04" };
    string[] sounds4 = { "UNIT_RESPONDING_DISPATCH_01", "UNIT_RESPONDING_DISPATCH_02", "UNIT_RESPONDING_DISPATCH_03", "UNIT_RESPONDING_DISPATCH_04", "UNIT_RESPONDING_DISPATCH_05", "UNIT_RESPONDING_DISPATCH_06", "UNIT_RESPONDING_DISPATCH_07", "UNIT_RESPONDING_DISPATCH_08" };
    string[] sounds5 = { "IN_02", "IN_02", "IN_03", "IN_04", "IN_05", "IN_02", "ON_01", "ON_02", "ON_03" };


    public Main()
    { 
        this.Tick += onTick;
        this.KeyUp += onKeyUp;
        this.KeyDown += onKeyDown;
        //Add the callout to the callout manager
        PoliceMod2.AI.CalloutMgr.CalloutNames.Add(CalloutRequest); 
    }

    private void onTick(object sender, EventArgs e)
    {
        //If the request is active
        if (requestactive)
        {
            //Show a notification for the options to the player
            UI.ShowSubtitle("Press ~g~Y ~w~to accept the callout or press ~r~N ~w~to decline it");
        }


        //Are we in a callout??
        if (accepted)
        {  
            //We died
        if (Game.Player.Character.IsDead)
        {
            //Remove enemies
            enemy.CurrentBlip.Remove();
            enemy.MarkAsNoLongerNeeded();  
            //You should actually end the callout here too, but i'll let you do that

        }
            //Blip follows player
            eventblip.Position = enemy.Position;

            //Enemy died, or the perp is arrested
            if (enemy.IsDead || Function.Call<bool>(GTA.Native.Hash.IS_PED_CUFFED, enemy))
            { 
                enemy.MarkAsNoLongerNeeded();
                // Show some cool notifications
                UI.Notify("~y~[Officer]~w~ Suspects taken care off, over.");
                UI.Notify("~g~[Toc]~w~ 10-4."); 
                //Fancy audio too??!
                Function.Call(GTA.Native.Hash.PLAY_MISSION_COMPLETE_AUDIO, "FRANKLIN_BIG_01");
                //Remove the blip
                eventblip.Remove(); 
                //Let's tell the callout manager we're done with the callout!
                PoliceMod2.AI.CalloutMgr.incallout = false;
  
                PoliceMod2.AI.CalloutMgr.AvaliableAgain();
                //Callout is over
                accepted = false;

            }
        }
        
    }

    void NoVoice()
    {
        int no = rand.Next(0, 3);
        Sound.SoundLocation = @location + "PoliceMod\\Sounds\\" + sounds3[no] + ".wav";
        Sound.PlaySync();
    }
    void RogerVoice()
    {
        try
        {
            Sound.SoundLocation = @location + "PoliceMod\\Sounds\\OFFICER_INTRO_01.wav";
            Sound.PlaySync();
            int no4 = rand.Next(0, 7);
            Sound.SoundLocation = @location + "PoliceMod\\Sounds\\" + sounds4[no4] + ".wav";
            Sound.PlaySync();
            Sound.SoundLocation = @location + "PoliceMod\\Sounds\\OUTRO_03.wav";
            Sound.PlaySync();

        }
        catch (Exception ex)
        {
            
        }
    }
    void Voice()
    {
        try
        {
            //Ignore all this, it'll be changed later
            location = System.Reflection.Assembly.GetExecutingAssembly().CodeBase.Replace("PoliceMod2.DLL", string.Empty);
            location.Replace("/", "\\");
            int no = rand.Next(0, 7);
            Sound.SoundLocation = @location + "PoliceMod\\Sounds\\" + sounds[no] + ".wav";
            Sound.PlaySync();
            Sound.SoundLocation = @location + "PoliceMod\\Sounds\\WE_HAVE_01.wav";
            Sound.PlaySync();
            int no2 = rand.Next(0, 7);
            Sound.SoundLocation = @location + "PoliceMod\\Sounds\\" + sounds2[no2] + ".wav";
            Sound.PlaySync();
            try
            {
                int no3 = rand.Next(0, 7);
                Sound.SoundLocation = @location + "PoliceMod\\Sounds\\" + sounds5[no3] + ".wav";
                Sound.PlaySync();
                Sound.SoundLocation = @location + "PoliceMod\\Sounds\\Streets\\" + name + ".wav";
                Sound.PlaySync();
            }
            catch (Exception ex)
            {
            }
            Sound.SoundLocation = @location + "PoliceMod\\Sounds\\OUTRO_03.wav";
            Sound.PlaySync();

        }
        catch (Exception ex)
        { 
            
        }
    }

    //When the callout has been chosen, have a option to accept or decline the callout here, its up to you how you do this
    public void CalloutRequest()
    {
        //If we haven't asked before
        if (!requestactive)
        {
            //Allowing random numbers to be created
            rand = new Random();
            //Finding a position on the street near the playe
            position = World.GetNextPositionOnStreet(Game.Player.Character.GetOffsetInWorldCoords(new Vector3(250, 250, 0)));
            //Creating a blip at that position to show where the allout will be
            eventblip = World.CreateBlip(position, 100);
            //Self explantory, setting colour, scale and sprite values
            eventblip.Sprite = BlipSprite.PoliceArea;
            eventblip.Scale = 100f;
            eventblip.Color = BlipColor.White;

            //Let's try get the street name at that location, using PoliceMod's built in systems
            string sname = PoliceMod2.Systems.Generic.StreetName(eventblip.Position);

            //Using random number to show variations of the callout
            int type = rand.Next(0, 10);
            if (type < 4)
            {
                //This let's you show a styled notification
                PoliceMod2.Systems.Generic.ShowNotification("Requesting backup, suspect refusing to pull over, Code 3. ~y~Location: ~w~" + sname, "Dispatch", true, "web_lossantospolicedept", "web_lossantospolicedept", 2);
            }
            else if (type > 4 && type < 8)
            {
                PoliceMod2.Systems.Generic.ShowNotification("Requesting backup, armed suspect fleeing in vehicle, Code 3. ~y~Location: ~w~" + sname, "Dispatch", true, "web_lossantospolicedept", "web_lossantospolicedept", 2);
            }
            else
            {
                PoliceMod2.Systems.Generic.ShowNotification("Requesting backup, high speed pursuit in progress, Code 3. ~y~Location: ~w~" + sname, "Dispatch", true, "web_lossantospolicedept", "web_lossantospolicedept", 2);
            }

            //Another way to get the street name, through scripthookdotnet's system
            OutputArgument streetHash = new OutputArgument();
            OutputArgument crossingHash = new OutputArgument();

            Function.Call(GTA.Native.Hash.GET_STREET_NAME_AT_COORD, eventblip.Position.X, eventblip.Position.Y, eventblip.Position.Z, streetHash, crossingHash);
            name = Function.Call<String>(GTA.Native.Hash.GET_STREET_NAME_FROM_HASH_KEY, streetHash.GetResult<int>());

            //We're gonna play audio in the near future, we need to get the directory of the audio files
            location = System.Reflection.Assembly.GetExecutingAssembly().CodeBase.Replace("PoliceMod2.DLL", string.Empty);
            location.Replace("/", "\\");

            //Lets start a new thread to play the audio of the request dispatch!
            Thread thread = new Thread(new ThreadStart(Voice));
            thread.Start();

            //We are now in a request, so we don't loop, we set a boolean.
            requestactive = true;
        }
    }
    private void onKeyDown(object sender, KeyEventArgs e)
    {
    }

    void StartCallout()
    {
        //Create a random ped
        enemy = World.CreateRandomPed(position);
        //Let's add a blip!
        enemy.AddBlip();
        //Make them walk around
        enemy.Task.WanderAround();
    }

    private void onKeyUp(object sender, KeyEventArgs e)
    {
        if (e.KeyCode == Keys.Y)
        {
            if (requestactive)
            {
                //Yes, we can respond the the callout.
                UI.Notify("~y~[Officer]~w~ Roger that, dispatch. En-route.");
                eventblip.Color = BlipColor.Red;
                requestactive = false;
                if (Game.Player.Character.Gender == Gender.Male)
                {
                    //Lets play the audio, if the player a male, because we don't have female clips currently :/
                    Thread thread = new Thread(new ThreadStart(RogerVoice));
                    thread.Start();
                }
                accepted = true;
                PoliceMod2.AI.CalloutMgr.incallout = true;
                StartCallout();
                requestactive = false;
            }
        }
        if (e.KeyCode == Keys.N)
        {
            if (requestactive)
            {
                //No, sorry we're busy.
                UI.Notify("~y~[Officer]~w~ Un-Able to assist, over.");
                eventblip.Remove();
                Thread thread = new Thread(new ThreadStart(NoVoice));
                thread.Start();
                requestactive = false;
                accepted = false;
                PoliceMod2.AI.CalloutMgr.incallout = false;
                PoliceMod2.AI.CalloutMgr.AvaliableAgain();
                requestactive = false;
            }
        }
    }
}